
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>rpc框架之 thrift 学习 1 - 安装 及 hello world / iVAN</title>

    <meta name="description" content="rpc框架之 thrift 学习 1 - 安装 及 hello world thrift是一个facebook开源的高效RPC框架,其主要特点是跨语言及二进制高效传输(当然,除了二进制,也支持json等常用序列化机制),官网地址:http://thrift.apache.org 跨语言通常有二种做法, 一是将其它语言转换成某种主流的通用语言,比如:delphi.net以前就是先将delphi转换成c#,然后再编译成IL,从而实现delphi在.net上的运行(好久没关注delphi了,不知道现在还是不是这种机制) 二是先定义一种规范文件(可以简单的理解为『母版』),然后">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">rpc框架之 thrift 学习 1 - 安装 及 hello world</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>thrift是一个facebook开源的高效RPC框架，其主要特点是跨语言及二进制高效传输（当然，除了二进制，也支持json等常用序列化机制），官网地址：<a href="http://thrift.apache.org" rel="external nofollow noreferrer">http://thrift.apache.org</a></p>
<p>跨语言通常有二种做法，</p>
<p>一是将其它语言转换成某种主流的通用语言，比如：delphi.net以前就是先将delphi转换成c#,然后再编译成IL，从而实现delphi在.net上的运行（好久没关注delphi了，不知道现在还是不是这种机制）</p>
<p>二是先定义一种规范文件（可以简单的理解为『母版』），然后由特定的编译器，将『母版』直接编译成目标语言的源代码。</p>
<p>thrift走的是第二条路，使用thrift框架时，先定义名为.thrift后缀的文件，然后由thrift编译器编译成指定语言的源文件，然后借助thrift提供的各种语言的实现lib库，完成rpc的调用。</p>
<p> </p>
<p>一、thrift编译器的安装 </p>
<p>1.1、windows 安装</p>
<p><a href="http://thrift.apache.org/docs/install/windows" rel="external nofollow noreferrer">http://thrift.apache.org/docs/install/windows</a> 这是官网的windows安装指导说明，windows的安装其实最简单</p>
<p><a href="http://www.apache.org/dyn/closer.cgi?path=/thrift/0.9.2/thrift-0.9.2.exe" rel="external nofollow noreferrer">Thrift compiler for Windows (thrift-0.9.2.exe)</a></p>
<p><a href="http://www.apache.org/dyn/closer.cgi?path=/thrift/0.9.2/thrift-0.9.2.tar.gz" rel="external nofollow noreferrer">thrift-0.9.2.tar.gz</a></p>
<p>下载这二个文件即可，第1个是编译器，第2个压缩包里包括了种示例代码。把thrift-0.9.2.exe保存到某个目录，比如：c:\thrift下，然后将thrift-0.9.2.exe改个简单的名字，比如：thrift.exe(这一步非必须)，最后在环境变量的path路径里，把c:\thrift加上，保证Command窗口下，键入thrift能找到该文件即可。</p>
<p>1.2、centos 安装 </p>
<p><a href="http://thrift.apache.org/docs/install/centos" rel="external nofollow noreferrer">http://thrift.apache.org/docs/install/centos</a> 参考这个安装，上面的详细的命令，按上面的命令一步步来就行了，主要过程是先安装一堆依赖的工具，然后</p>
<p>git clone https://git-wip-us.apache.org/repos/asf/thrift.git</p>
<p>将thrift源代码拉到本地，再build，生成thrift编译器</p>
<p>1.3、mac osx 安装</p>
<p><a href="http://thrift.apache.org/docs/install/os_x" rel="external nofollow noreferrer">http://thrift.apache.org/docs/install/os_x</a> 参考这里，大概步骤跟centos差不多，相信大家都能搞定，唯一要注意的是，mac os上没有yum之类的工具，建议使用<a href="http://brew.sh" rel="external nofollow noreferrer">brew</a> 工具安装</p>
<p> </p>
<p>二、thrift文件的定义</p>
<p>从git拉回来的源代码tutorial目录下，有二个示例文件：shared.thrift及tutorial.thrift，大家可以打开看看，演示了主要用法，但我觉得还是有些小复杂，初学者一眼看上去有些乱，我按服务开发的常规场景，自己弄了二个小demo:</p>
<p>首先定义要传输的dto对象</p>
<p>dto.thrift</p>
<pre>namespace java yjmyzz.thrift.study.dto
namespace csharp yjmyzz.thrift.study.dto

//Person类
struct Person {
  1: i16 age = 0,
  2: string name,
  3: bool sex,
  4: double salary,
  5: byte childrenCount
}

//查询参数
struct QueryParameter{
 1: i16 ageStart,
 2: i16 ageEnd
}</pre>
<p>这里定义了二个类，一个是Person类，一个是查询的参数对象类，最上面的namespace即为最终java, c#里的package及namespace</p>
<p>再定义服务接口service.thrift</p>
<pre>namespace java yjmyzz.thrift.study.service
namespace csharp yjmyzz.thrift.study.service

include "dto.thrift"

//服务
service DemoService {

   //用于检测client-server之间通讯是否正常
   string ping(),

   list&lt;dto.Person&gt; getPersonList(1:dto.QueryParameter parameter)

}</pre>
<p>实际开发中，建议大家使用intellij idea，其thrift插件可以支持高亮语法和代码智能提示，如下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hZDg4YjJmOGJkZjE1YzQ3YTNlN2E4M2Y4ZWViMDE4Ny5wbmc=.jpg"></p>
<p> </p>
<p>三、client及server端项目开发</p>
<p>如果大家使用过hessian、dubbo之类的框架，相信对于服务开发这一类套路都很熟悉，通常会拆分成3部分，接口定义（也称服务&amp;数据契约 contract）、服务生产方(即：server端)、服务消费方(即：client端)，按这一思路，创建三个module，项目结构见下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MGZmMmQ4Y2VkMjdmMmZmYzY5ZjdlOTY2M2Q5YWYzMS5wbmc=.jpg"></p>
<p>其中thrift-contract即为公用的接口部分，thrift-client为客户端，thrift-server为服务端，注意：dto.thrift及service.thrift这二个文件，我放在了thrift-contract\src\thrift这个目录下。</p>
<p>3.1 生成目标语言源文件</p>
<p>架势拉好了，开始干活，命令行下先进入thrift-contract\src\thrift所在目录，</p>
<p>thrift -gen java dto.thrift</p>
<p>thrift -gen java service.thrift</p>
<p>这样就把二个thrift【母版】文件生成了对应的java代码，生成的源文件会存放在当前工作目录的gen-java下，如果把-gen java换成-gen csharp就会生成c#代码。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180ODExZmRjMmE0MzY5YTM2N2E1OWI0ZWU1ZDc4ZWE2Ny5wbmc=.jpg"></p>
<p>上图是生成后的源代码结构，由于src\thrift目录并不是maven工程约定的源代码目录，手动把gen-java下生成的整个目录，复制到src/main/java下即可。</p>
<p>3.2 maven中pom.xml依赖荐的添加</p>
<pre> 1     &lt;dependencies&gt;
 2         &lt;dependency&gt;
 3             &lt;groupId&gt;org.apache.thrift&lt;/groupId&gt;
 4             &lt;artifactId&gt;libthrift&lt;/artifactId&gt;
 5             &lt;version&gt;0.9.2&lt;/version&gt;
 6         &lt;/dependency&gt;
 7
 8         &lt;dependency&gt;
 9             &lt;groupId&gt;org.slf4j&lt;/groupId&gt;
10             &lt;artifactId&gt;slf4j-log4j12&lt;/artifactId&gt;
11             &lt;version&gt;1.5.8&lt;/version&gt;
12         &lt;/dependency&gt;
13     &lt;/dependencies&gt;</pre>
<p>libthrift这一项是必须要添加的，slf4j-log4j12对于接口定义来讲，可以不用（但最终在server\client端运行时，这个包不可少）。然后就可以用 mvn clean install 来生成jar包并安装到本机maven仓库中了，注意这里有一个小问题：</p>
<p>thrift生成的java源代码中，@Override这个注解有些地方添加得不对（比如：实现接口时，实现类中是不需要添加这一注解的），编译时如果出现错误，直接去掉即可，建议：将生成的java源文件，全局替换，把@Override全干掉。</p>
<p>3.3 server端的接口实现</p>
<p>thrift-contract只是生成了服务的接口定义，并未提供实现，下面是DemoService的实现</p>
<pre>package yjmyzz.thrift.study;

import org.apache.thrift.TException;
import yjmyzz.thrift.study.dto.Person;
import yjmyzz.thrift.study.dto.QueryParameter;
import yjmyzz.thrift.study.service.DemoService;

import java.util.ArrayList;
import java.util.List;

public class DemoServiceImpl implements DemoService.Iface {

    public String ping() throws TException {
        System.out.println("ping()");
        return "pong";
    }

    public List&lt;Person&gt; getPersonList(QueryParameter parameter) throws TException {
        //System.out.println(parameter.getAgeStart() + " - " + parameter.getAgeEnd());

        List&lt;Person&gt; list = new ArrayList&lt;Person&gt;(10);
        for (short i = 0; i &lt; 10; i++) {
            Person p = new Person();
            p.setAge(i);
            p.setChildrenCount(Byte.valueOf(i + ""));
            p.setName("test" + i);
            p.setSalary(10000D);
            p.setSex(true);
            list.add(p);
        }
        return list;
    }
}
</pre>
<p> 这里随便返回一堆数据，意思一下而已，注：server端的pom.xml中，记得添加接口层的依赖项引用 </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1     &lt;dependencies&gt;
 2
 3         &lt;dependency&gt;
 4             &lt;groupId&gt;yjmyzz&lt;/groupId&gt;
 5             &lt;artifactId&gt;thrift-contract&lt;/artifactId&gt;
 6             &lt;version&gt;1.0&lt;/version&gt;
 7         &lt;/dependency&gt;
 8
 9         &lt;dependency&gt;
10             &lt;groupId&gt;org.apache.thrift&lt;/groupId&gt;
11             &lt;artifactId&gt;libthrift&lt;/artifactId&gt;
12             &lt;version&gt;0.9.2&lt;/version&gt;
13         &lt;/dependency&gt;
14
15         &lt;dependency&gt;
16             &lt;groupId&gt;org.slf4j&lt;/groupId&gt;
17             &lt;artifactId&gt;slf4j-log4j12&lt;/artifactId&gt;
18             &lt;version&gt;1.5.8&lt;/version&gt;
19         &lt;/dependency&gt;
20     &lt;/dependencies&gt;</pre>
<p>View Code</p>
<p>3.4 server的启动</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package yjmyzz.thrift.study;
 2
 3
 4 import org.apache.thrift.server.TServer;
 5 import org.apache.thrift.server.TServer.Args;
 6 import org.apache.thrift.server.TSimpleServer;
 7 import org.apache.thrift.transport.TServerSocket;
 8 import org.apache.thrift.transport.TServerTransport;
 9 import yjmyzz.thrift.study.service.DemoService;
10
11
12 public class ThriftServer {
13
14     public static DemoService.Iface service;
15
16     public static DemoService.Processor processor;
17
18     public static void main(String[] args) {
19         try {
20             service = new DemoServiceImpl();
21             processor = new DemoService.Processor(service);
22
23             Runnable simple = new Runnable() {
24                 public void run() {
25                     simple(processor);
26                 }
27             };
28             new Thread(simple).start();
29
30         } catch (Exception x) {
31             x.printStackTrace();
32         }
33     }
34
35     public static void simple(DemoService.Processor processor) {
36         try {
37             TServerTransport serverTransport = new TServerSocket(9090);
38             TServer server = new TSimpleServer(new Args(serverTransport).processor(processor));
39             System.out.println("Starting the simple server...");
40             server.serve();
41         } catch (Exception e) {
42             e.printStackTrace();
43         }
44     }
45
46
47 }</pre>
<p>View Code</p>
<p>这里监听9090端口，响应client的调用请求。 </p>
<p>3.5 client调用示例</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg"></p>
<pre> 1 package yjmyzz.thrift.study;
 2
 3 import org.apache.thrift.TException;
 4 import org.apache.thrift.protocol.TBinaryProtocol;
 5 import org.apache.thrift.protocol.TProtocol;
 6 import org.apache.thrift.transport.TSocket;
 7 import org.apache.thrift.transport.TTransport;
 8 import yjmyzz.thrift.study.dto.QueryParameter;
 9 import yjmyzz.thrift.study.service.DemoService;
10
11 public class ThriftClient {
12
13     public static void main(String[] args) {
14
15         try {
16             TTransport transport;
17             transport = new TSocket("localhost", 9090);
18             transport.open();
19
20             TProtocol protocol = new TBinaryProtocol(transport);
21             DemoService.Client client = new DemoService.Client(protocol);
22
23             System.out.println(client.ping());
24
25             int max = 100000;
26
27             Long start = System.currentTimeMillis();
28
29             for (int i = 0; i &lt; max; i++) {
30                 call(client);
31             }
32
33             Long end = System.currentTimeMillis();
34
35             Long elapse = end - start;
36
37             int perform = Double.valueOf(max / (elapse / 1000d)).intValue();
38
39             System.out.print("thrift " + max + " 次RPC调用，耗时：" + elapse + "毫秒，平均" + perform + "次/秒");
40
41             transport.close();
42
43         } catch (TException x) {
44             x.printStackTrace();
45         }
46     }
47
48     private static void call(DemoService.Client client) throws TException {
49
50         //client.ping();
51         //System.out.println("ping()=&gt;" + client.ping());
52
53         QueryParameter parameter = new QueryParameter();
54         parameter.setAgeStart(Short.valueOf("5"));
55         parameter.setAgeEnd(Short.valueOf("50"));
56
57         client.getPersonList(parameter);
58         //System.out.println(client.getPersonList(parameter));
59     }
60 }</pre>
<p>View Code </p>
<p>在我mac老爷本（2011年买的）上测试出来的结果，而且server使用的SimpleServer同步阻塞模式，如果采用多线程非阻塞模式，在服务器上性能相信至少还能翻N倍不成问题：</p>
<p><em>thrift 100000 次RPC调用，耗时：7774毫秒，平均12863次/秒</em></p>
<p>即使按这个结果来估算，1秒至少处理1w次，1小时3600秒就是3.6kw次，1天24小时，每天处理上亿次调用毫无压力，相信已经能满足很多公司的要求了。而且thrift出来很多年了，相对比较成熟，如果项目是异构系统，要兼容多种语言之间的相互调用，thrift是不错的选择。</p>
<p> </p>
<p>但最后也提醒一下，thrift虽然跨语言不假，但是在不同语言的实现上，性能相差甚远，上面的示例client、server都是采用java开发，如果把server换成c#，结果就惨不忍睹了（相差几个数量级），大家可以自行测试，建议实际项目中，至少server端使用java语言（或c++）开发。</p>
<p> </p>
<p>另外在使用上，有一些小限制：一个Server只能对应一个Service接口，也就是说，如果有多个服务，要么融合成一个大接口，要么启多个server(对应多个端口)</p>
<p> </p>
<p>附文中源码下载：</p>
<p><a href="http://code.taobao.org/svn/thrift-java/" rel="external nofollow noreferrer">http://code.taobao.org/svn/thrift-java/</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 00:37:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/ping/" title="Ping">Ping</a>, <a href="https://www.iamivan.net/tag/service/" title="service">service</a>, <a href="https://www.iamivan.net/tag/rpc/" title="rpc">rpc</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>rpc框架之 thrift 学习 1 - 安装 及 hello world的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5NG8nz.html" rel="bookmark">rpc框架之 thrift 学习 2 - 基本概念</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				thrift的基本构架: 上图源自:http://jnb.ociweb.com/jnb/jnbJun2009.html 底层Underlying I/O以上的部分,都是由thrift编译器生成的代码,其中: Your Code 这是根据thrift文件中定义的dto及service接口方法 FooService.Client及FooService.Processer是thrift生成的用于客户端及服务端的标准代码 Foo.read/write 参数对象及结果对象在传输时,最终需要在client.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXdwBAp.html" rel="bookmark">rpc框架之gRPC 学习 - hello world</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				grpc是google在github于2015年开源的一款RPC框架,虽然protobuf很早google就开源了,但是google一直没推出正式的开源框架,导致github上基于protobuf的rpc五花八门,国内比较著名的有百度的sofa-pbrpc,但是遗憾的是soft-pbrpc没有对应的java实现版本.rgpc还有一个独立的官网:http://www.grpc.io/,目前已经支持的语言有 C, C++, Java, Go, Node.js, Python, Ruby, Objec			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx04o7M.html" rel="bookmark">rpc框架之 avro 学习 2 - 高效的序列化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同一类框架,后出现的总会吸收之前框架的优点,然后加以改进,avro在序列化方面相对thrift就是一个很好的例子.借用Apache Avro 与 Thrift 比较 一文中的几张图来说明一下,avro在序列化方面的改进: 1.无需强制生成目标语言代码 avro提供了二种使用方式,一种称之为Sepcific方式,这跟thrift基本一致,都是写定义IDL文件,然后用编译器(或插件)生成目标class,另一种方式是Generic,这种方式下,不用生成目标代码,而是采用动态加载定义文件的方式,将 Fi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjRrwM.html" rel="bookmark">rpc框架之avro 学习 1 - hello world</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				avro是hadoop的一个子项目,提供的功能与thrift.Protocol Buffer类似,都支持二进制高效序列化,也自带RPC机制,但是avro使用起来更简单,无需象thrift那样生成目标语言源代码,目前支持的语言有java.c#.php.c++等(详情见:https://cwiki.apache.org/confluence/display/AVRO/Supported+Languages),hadoop生态圈中的hive.pig已经在使用avro avro-client模块中的po			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZJyKb.html" rel="bookmark">开源RPC（gRPC&sol;Thrift）框架性能评测</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				海量互联网业务系统只能依赖分布式架构来解决,而分布式开发的基石则是RPC:本文主要针对两个开源的RPC框架(gRPC. Apache Thrift),以及配合GoLang.C++两个开发语言进行性能对比分析.C++.Thrift都是比较成熟的技术,先简单介绍一下GoLang以及gRPC:   GoLang Go语言是由Google开发的一个开源项目,目的之一为了提高开发人员的编程效率. Go语言语法灵活.简洁.清晰.高效.它对的并发特性可以方便地用于多核处理器 和网络开发,同时灵活新颖的类型系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVdNnYM.html" rel="bookmark">rpc框架&colon; thrift&sol;avro&sol;protobuf 之maven插件生成java类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				thrift.avro.probobuf 这几个rpc框架的基本思想都差不多,先定义IDL文件,然后由各自的编译器(或maven插件)生成目标语言的源代码,但是,根据idl生成源代码这件事,如果每次都要手动敲命令,未免太无聊了,幸好这三种框架都提供了对应的maven插件来完成代码的自动生成,本文演示了这三种框架的maven插件用法. 一.maven-thrift-plugin 1 &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW1x5Xz.html" rel="bookmark">基于zeromq的高性能分布式RPC框架Zerorpc 性能测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Zeromq 是基于zeromq.gevent和 msgpack开发的分布式RPC框架zerorpc-python.这个框架简单.易用. 1. 安装zeromq yum -y install zeromq yum install gcc gcc-c++ libuuid-devel python-uuid uuid wget http://download.zeromq.org/zeromq-2.1.9.tar.gz ./configure make make install 2.安装gevent			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGQLWp.html" rel="bookmark">一个轻量级分布式RPC框架--NettyRpc</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.背景 最近在搜索Netty和Zookeeper方面的文章时,看到了这篇文章&lt;轻量级分布式 RPC 框架&gt;,作者用Zookeeper.Netty和Spring写了一个轻量级的分布式RPC框架.花了一些时间看了下他的代码,写的干净简单,写的RPC框架可以算是一个简易版的dubbo.这个RPC框架虽小,但是麻雀虽小,五脏俱全,有兴趣的可以学习一下. 本人在这个简易版的RPC上添加了如下特性: * 服务异步调用的支持,回调函数callback的支持 * 客户端使用长连接(在多次调用共享连接) *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQeGLp.html" rel="bookmark">Alluxio源码分析：RPC框架浅析（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        Alluxio源码分析是一个基于内存的分布式文件系统,和HDFS.HBase等一样,也是由主从节点构成的.而节点之间的通信,一般都是采用的RPC通讯模型.Alluxio中RPC是基于何种技术如何实现的呢?它对于RPC请求是如何处理的?都涉及到哪些组件?本文将针对这些问题,为您一一解答.         一.Alluxio中RPC实现技术支持         Alluxio中的RPC是依靠Thrift实现的,Apache Thrift 是 Facebook 实现的一种高效的.支持多			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5NoRz.html" rel="bookmark" class="title">你家的Wi-Fi被蹭了！你造吗？简单6招解决蹭网问题</a>
					<div>
						  现在很多智能路由器都自带手机APP,可以随时查看联网的设备,踢到蹭网设备也是轻而易举.但路由器不是年抛设备,很多人都还用着老古董,对于它们,应该如何查看是否被蹭网呢?又该如何规避呢?下面简单6招解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOlgvb.html" rel="bookmark" class="title">运维日常工作知识总结</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://navyaijm.blog.51cto.com/4647068/1242890 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdDW6p.html" rel="bookmark" class="title">模拟条形码制作</a>
					<div>
						条形码 教程开始之前,首先请看如下所示效果: 在FW4里面产生如图所示的模拟条形码效果是比较容易的,但是我们要首先明确一点,那就是这种条形码的效果我们只能是进行模拟制作,如果想要精细的制作一个正规的严 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeYOOz.html" rel="bookmark" class="title">小屏幕移动设备界面设计WAP页设计注意事项</a>
					<div>
						网页制作Webjx文章简介:小屏幕移动设备网页设计注意事项. 在过去,小屏幕移动设备网页通常也被称之为WAP页,或WAP站.原因是这类网页起源于一个叫WAP的无线协议.WAP能够运行于各种无线网络之上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5B76z.html" rel="bookmark" class="title">SEO基础篇&colon; 案例分析404错误页面</a>
					<div>
						每当我们打开一网站时如果长时间没有反应时,或者URL错误时会看到下面这种情景:   这个错误页面就是404页面,今天上海SEO潇然孤雁飞就和大家聊一聊404这个家喻户晓的SEO基本知识. 404页面就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLZaAb.html" rel="bookmark" class="title">刘金鸽：SEO行业四大险境的全面剖析</a>
					<div>
						现在每天的SEO变成了每天的发贴.发链接.我就说如果按照这样的发展势头,做SEO工作都到底还有几年的路程可以走?我写这篇文章也是为了探讨这个问题.而对于当今的互联网环境,SEO工作者总共有以下几个难题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEwaZp.html" rel="bookmark" class="title">CUDA线程执行模型分析（二）大军未动粮草先行---GPU的革命</a>
					<div>
						序:今天或许是比较不顺心的一天,从早上第一个电话,到下午的一些列的事情,有些许的失落.有的时候真的很想把工作和生活完全分开,但是谁又能真正的分得那么开,人非草木!很多的时候都想给人生下一些定义,添加一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk24ArM.html" rel="bookmark" class="title">在VisualStudio中使用Windows桌面搜索</a>
					<div>
						本文将介绍以下内容: •创建 Visual Studio 加载项 •创建加载项工具窗口 •使用 Windows 桌面搜索进行开发 本文涉及以下技术: Visual Studio 2005 和 Wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Pnq0M.html" rel="bookmark" class="title">服务器如何防入侵加固</a>
					<div>
						无论是对技术的喜好,还是金钱诱惑,或者是政治利益驱使,黑客们主打的入侵与攻击技术的发展速度都明显在加快.安全厂家好像也很努力,但总是在自己的销售利益上走来走去,从最初的老三样(防火墙FW.入侵检测ID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7VyxM.html" rel="bookmark" class="title">flash时间轴教程</a>
					<div>
						时间轴用于组织和控制文档内容在一定时间内播放的图层数和帧数.与胶片一样, Flash 文档也将时长分为帧.图层就像堆叠在一起的多张幻灯胶片一样,每个图层都包含一个显示在舞台中的不同图像.时间轴的主要组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oZW3b.html" rel="bookmark" class="title">ps将人物头像印到硬币上方法</a>
					<div>
						  纵所周知,很多硬币的背面往往会印有一个人物的头像,一般这类人都是极其有名望的人,很多人都想体验一下将自己头像印上去是什么感觉,那么如何利用ps将头像印到硬币上呢,下面我将为大家讲解一下这种方法的制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywgkZz.html" rel="bookmark" class="title">百度云管家上传和离线可用文件是否会消耗流量？</a>
					<div>
						  上传和离线可用会消耗流量,请尽量选择在Wi-Fi环境下进行操作.您也可以选择&quot;仅在Wi-Fi下上传下载&quot;选项,当您的网络环境在非Wi-Fi环境下,不会对传输列表中的文件进行传输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42XJjM.html" rel="bookmark" class="title">win7系统实现一键关机设置教程</a>
					<div>
						  那么windows7系统下如何实现一键轻松关机呢? 下面跟大家分享下相关的设置教程以及图文步骤. 选择[开始]-[控制面板],打开系统控制面板窗口 在控制面板窗口下选择[系统和安全],这里面的电源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWaVGb.html" rel="bookmark" class="title">格式化工厂怎么把MP3转换m4r格式铃声</a>
					<div>
						  一.首先在电脑中下载安装&quot;格式化工厂&quot;转换工具,下载安装后直接打开运行,然后点击左侧的&quot;音频&quot;之后在点击&quot;M4R&quot;如下图所示. 二.由于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLayv8z.html" rel="bookmark" class="title">怎么安装Java Runtime Environment</a>
					<div>
						Java Runtime Environment是运行java程序所必需的最小安装包,是java的核心运行环境.那么我们要怎么安装Java Runtime Environment,小编给大家提供Jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmdvZz.html" rel="bookmark" class="title">android 应用接入微信支付sdk</a>
					<div>
						问题描述 android 应用接入微信支付sdk android 应用接入微信支付sdk 求思路.......... 解决方案 1.进入微信开放平台网站(https://open.weixin.qq. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxPgdb.html" rel="bookmark" class="title">初始化python类的实例时，私有变量的值与上一个实例的相同，问题定位</a>
					<div>
						#!/usr/bin/env python # -*- Coding=UTF-8 -*- class parser: def __init__(self, x=[]): print &quot;ear ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVjYEb.html" rel="bookmark" class="title">用Canvas&plus;Javascript FileAPI 实现一个跨平台的图片剪切、滤镜处理、上传下载工具（转）</a>
					<div>
						直接上代码,其中上传功能需要自己配置允许跨域的文件服务器地址~ 或者将html文件贴到您的站点下同源上传也OK. 支持: 不同尺寸图片获取. 原图缩小放大. 原图移动. 选择框大小改变. 下载选中的区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAyP3M.html" rel="bookmark" class="title">对于一个偶尔高并发的活动页面（涉及db操作，db为mysql，集群部署），你怎么做</a>
					<div>
						问题描述 对于一个偶尔高并发的活动页面(涉及db操作,db为mysql,集群部署),你怎么做 对于一个偶尔高并发的活动页面(涉及db操作,db为mysql,集群部署),你怎么做 解决方案 高并发的话, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqEEBb.html" rel="bookmark" class="title">本机访问IIS 127&period;0&period;0&period;1 出现HTTP 错误 500&period;100 - 内部服务器错误 - ASP 错误</a>
					<div>
						问题描述 如题,今天再次装了一下IIS5.1I386同上次一样出现同样的问题,首先第一个是没有访问权限,IUSER更改以后,出现了无法显示网页试图访问的网页出现问题,无法显示.------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoZGmb.html" rel="bookmark" class="title">html-超链接中title&equals;变量为什么显示的是变量名而不是变量的值</a>
					<div>
						问题描述 超链接中title=变量为什么显示的是变量名而不是变量的值 超链接中title=变量为什么显示的是变量名而不是变量的值,求告知+++++++++++++++++ 解决方案 你怎么写的,jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD1Ydz.html" rel="bookmark" class="title">&period;net，未能加载文件或程序集&OpenCurlyDoubleQuote;Infragistics2&rdquo;</a>
					<div>
						问题描述 问题:未能加载文件或程序集&quot;Infragistics2.Web.v11.2,Version=11.2.20112.1019,Culture=neutral,PublicKeyTok ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKP70z.html" rel="bookmark" class="title">阿里去年Q4盈利超腾讯</a>
					<div>
						新京报讯 (记者刘夏)雅虎5月7日晚间提交给美国http://www.aliyun.com/zixun/aggregation/6074.html&quot;&gt;证券交易委员会(SEC)的文件显示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA6E6p.html" rel="bookmark" class="title">要慎重对待广告任务网</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 很多网赚博客,网赚网站的站长,很热 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZL5Ap.html" rel="bookmark" class="title">使用正则表达式替换表情符号核心代码</a>
					<div>
						复制代码 代码如下: String a = &quot;哇哈哈哈[em:5]aa8888[em:7]&quot;; String r = &quot;\\[em:(\\d+)\\]&quot;; a  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq77Wez.html" rel="bookmark" class="title">编码 unicode 及其在 javascript 中的使用</a>
					<div>
						编码 unicode 及其在 javascript 中的使用 一.javascript 使用 unicode16 字符集,可以使用中文变量名和函数名 计算机使用 8 位(bit)二进制表示一个字节(B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60Ajyz.html" rel="bookmark" class="title">智能家居进入冷静期 海尔开放开发者平台圈生态资源</a>
					<div>
						物联网时代,拼的是生态. 6月23日下午,海尔宣布开放U+智慧生活平台的SDK软件包,它为开发者搭建的开放的开发平台&quot;海极网&quot;2.0正式上线,以整合更多的生态资源. 海尔U+推广总 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1yY3b.html" rel="bookmark" class="title">大数据在政府部门的应用</a>
					<div>
						政府使用大数据是为了提升和改善公共服务,这与企业利用其追求利润异曲同工. 大数据是从各种各样来源中搜集得到的海量数据信息的总称.对于传统的关系型数据分析技术来说,其数据量太大,未经处理,同时也是非结构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlKYlp.html" rel="bookmark" class="title">PHP CURL模拟登录新浪微博抓取页面内容 基于EaglePHP框架开发&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: /** * CURL请求 * @param String $url 请求地址 * @param Array $data 请求数据 */ function curlRequest( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLPOdM.html" rel="bookmark" class="title">javascript 常用代码技巧大收集&lowbar;表单特效</a>
					<div>
						1.文本框焦点问题 onBlur:当失去输入焦点后产生该事件 onFocus:当输入获得焦点后,产生该文件 Onchange:当文字值改变时,产生该事件 Onselect:当文字加亮后,产生该文件 & ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
